---
- name: Docker | Update APT cache
  ansible.builtin.shell: sudo apt-get update
    #
    #    - name: Install backports.ssl-match-hostname module
    #      pip:
    #        name: backports.ssl-match-hostname
    #        state: present
    #

- name: Docker | Uninstall old versions and conflicting packages
  ansible.builtin.shell: |
    for pkg in docker.io docker-doc docker-compose docker-compose-v2 podman-docker containerd runc; do
      sudo apt-get remove -y $pkg || true
    done

- name: Docker | Install required packages
  ansible.builtin.shell: sudo apt-get install -y ca-certificates curl gnupg

- name: Docker | Create directory for keyring
  ansible.builtin.shell: sudo install -m 0755 -d /etc/apt/keyrings

- name: Docker | Remove Docker GPG key file
  become: true
  file:
    path: /etc/apt/keyrings/docker.gpg
    state: absent

- name: Docker | Download Docker GPG key
  ansible.builtin.shell: curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo gpg --dearmor -o /etc/apt/keyrings/docker.gpg

- name: Docker | Set permissions for Docker GPG key
  ansible.builtin.shell: sudo chmod a+r /etc/apt/keyrings/docker.gpg

- name: Docker | Add Docker repository lines
  ansible.builtin.shell: |
    echo "deb [arch=$(dpkg --print-architecture) signed-by=/etc/apt/keyrings/docker.gpg] https://download.docker.com/linux/ubuntu  $(. /etc/os-release && echo $VERSION_CODENAME) stable" | sudo tee /etc/apt/sources.list.d/docker.list > /dev/null

- name: Docker | Update APT cache again
  ansible.builtin.shell: sudo apt-get update

- name: Docker | Install Docker packages
  ansible.builtin.shell: sudo apt-get install -y docker-ce docker-ce-cli containerd.io docker-buildx-plugin docker-compose-plugin

- name: Docker | Add the user {{ pc_host_user }} to the docker Group
  become: true
  user:
    name: "{{ pc_host_user }}"
    state: present
    append: true
    groups: docker
